unit TestUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ODCalend, StdCtrls, Buttons, ODPopCal;

type
  TTestForm = class(TForm)
    ODPopupCalendar1: TODPopupCalendar;
    Button1: TButton;
    Edit1: TEdit;
    ODCalendar1: TODCalendar;
    ODCalendarDialog1: TODCalendarDialog;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure ODCalendar1SetupDay(Sender: TObject; Date: TDateTime;
      var AColor: TColor; var AHint: String);
    procedure ODCalendar1SelectYear(Sender: TObject; Year: Integer;
      var YearStart, YearFinish: TDateTime);
  end;

var
  TestForm: TTestForm;

implementation

{$R *.DFM}

procedure TTestForm.FormShow(Sender: TObject);
begin
{ ODCalendar1.StartDate := EncodeDate(1998, 1, 15);
  ODCalendar1.FinishDate := Date;}
  ODPopupCalendar1.StartDate := Date - 14;
  ODPopupCalendar1.FinishDate := Date;
end;

procedure TTestForm.Button1Click(Sender: TObject);
begin
  with ODCalendarDialog1 do
    if Execute then
      if SingleDate then
        Edit1.Text := FormatDateTime(DateFormat, StartDate)
      else
        Edit1.Text := FormatDateTime(DateFormat, StartDate) +
          ' - ' + FormatDateTime(DateFormat, FinishDate);
end;

procedure TTestForm.CheckBox1Click(Sender: TObject);
begin
  with CheckBox1 do
  begin
    ODCalendar1.SingleDate := Checked;
    ODPopupCalendar1.SingleDate := Checked;
    ODCalendarDialog1.SingleDate := Checked;
    if Checked then
      ODPopupCalendar1.PopupCaption := 'Select A Date'
    else
      ODPopupCalendar1.PopupCaption := 'Select Date Range';
    ODCalendarDialog1.Caption := ODPopupCalendar1.PopupCaption;
  end;
end;

procedure TTestForm.CheckBox2Click(Sender: TObject);
begin
  ODCalendar1.ShowStatus := CheckBox2.Checked;
  ODPopupCalendar1.ShowStatus := CheckBox2.Checked;
  ODCalendarDialog1.ShowStatus := CheckBox2.Checked;
end;

procedure TTestForm.CheckBox3Click(Sender: TObject);
begin
  ODCalendar1.StartOnMonday := CheckBox3.Checked;
  ODPopupCalendar1.StartOnMonday := CheckBox3.Checked;
  ODCalendarDialog1.StartOnMonday := CheckBox3.Checked;
end;

procedure TTestForm.ODCalendar1SetupDay(Sender: TObject; Date: TDateTime;
  var AColor: TColor; var AHint: String);
begin
  if Date = EncodeDate(1998, 2, 8) then
  begin
    AColor := clOlive;
    AHint := 'Happy birthday!';
  end
  else if Date = EncodeDate(1998, 2, 12) then
  begin
    AColor := clRed;
    AHint := 'Important!';
  end;
end;

procedure TTestForm.ODCalendar1SelectYear(Sender: TObject; Year: Integer;
  var YearStart, YearFinish: TDateTime);
begin
  if Year = 1998 then
  begin
    YearStart := EncodeDate(1998, 1, 4);
    YearFinish := EncodeDate(1999, 1, 2);
  end;
end;

end.
